[TASK] Put commit hooks into Build/git-hooks directory 73/55973/2
authorSybille Peters <sypets@gmx.de>
Wed, 14 Feb 2018 09:41:20 +0000 (10:41 +0100)
committerChristian Kuhn <lolli@schwarzbu.ch>
Thu, 1 Mar 2018 16:58:45 +0000 (17:58 +0100)
* commit-msg hook: change wiki link to link to official contribution guide
* commit-msg hook: rebase with original source
* commit-msg hook: add Change-Id on last line after footer
* pre-commit hook: check if staged php files conform to coding guidelines
* Build/Scripts/cglFixMyCommit.sh: extended
  parameters to be used by new pre-commit hook

Resolves: #83891
Releases: master, 8.7, 7.6
Change-Id: I6d00aa32ef3f9517d88e90c40059c7f73d7f6cfe
Reviewed-on: https://review.typo3.org/55973
Reviewed-by: Frank Naegler <frank.naegler@typo3.org>
Tested-by: Frank Naegler <frank.naegler@typo3.org>
Tested-by: TYPO3com <no-reply@typo3.com>
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>
Build/Scripts/cglFixMyCommit.sh
Build/git-hooks/commit-msg [new file with mode: 0755]
Build/git-hooks/unix+mac/pre-commit [new file with mode: 0755]

index ce7172d..11514ce 100755 (executable)
@@ -1,8 +1,8 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
 #########################
 #
-# CGL check latest core commit.
+# CGL fix.
 #
 # It expects to be run from the core root.
 #
 #
 ##########################
 
-php_no_xdebug () {
+# --------------------------
+# --- default parameters ---
+# --------------------------
+# check files in last commit
+filestype=commit
+# non-dryrun is default
+DRYRUN=""
+DRYRUN_OPTIONS="--dry-run --diff --diff-format udiff"
+
+# ----------------------
+# --- automatic vars ---
+# ----------------------
+progname=$(basename $0)
+
+# ------------------------
+# --- print usage info ---
+# ------------------------
+usage()
+{
+    echo "Usage: $0 [options]                                      "
+    echo " "
+    echo "no arguments/default: fix all php files in last commit   "
+    echo " "
+    echo "Options:                                                 "
+    echo " -f <commit|cache|stdin>                                 "
+    echo "      specifies which files to check:                    "
+    echo "      - commit (default): all files in latest commit     "
+    echo "      - cache : all files in git cache (staging area)    "
+    echo "      - stdin : read list of files from stdin            "
+    echo " "
+    echo " -n                                                      "
+    echo "      dryrun only, do not fix anything!                  "
+    echo " "
+    echo " -h                                                      "
+    echo "      help                                               "
+    echo " "
+    echo "Note: In order to still support command line options of  "
+    echo " older versions of this script, you can use the argument "
+    echo " dryrun.                                                 "
+    echo " "
+    echo " THIS IS NOT RECOMMENDED but will still work for now     "
+    echo " Usage: $0 [options] [dryrun]                            "
+    exit 0
+}
+
+# -----------------------
+# --- parsing of args ---
+# -----------------------
+OPTIND=1
+
+while getopts "hnf:" opt;do
+    case "$opt" in
+    h)
+        usage
+        ;;
+    f)
+        filestype=$OPTARG
+        echo "$0 files type=$filestype"
+        ;;
+    n)
+        echo "$progname: dryrun mode"
+        DRYRUN="$DRYRUN_OPTIONS"
+        ;;
+    esac
+done
+
+shift $((OPTIND-1))
+
+if [ "$1" = "dryrun" ]
+then
+    echo "$progname: dryrun mode"
+    DRYRUN="$DRYRUN_OPTIONS"
+fi
+
+# --------------------------------------
+# --- check if php executable exists ---
+# --------------------------------------
+exist_php_executable() {
+    which php >/dev/null 2>/dev/null
+    if [ $? -ne 0 ];then
+        echo "$progname: No php executable found\n"
+        exit 1
+    fi
+}
+
+
+# ------------------------------
+# --- run php without xdebug ---
+# ------------------------------
+php_no_xdebug ()
+{
     temporaryPath="$(mktemp -t php.XXXX).ini"
     php -i | grep "\.ini" | grep -o -e '\(/[A-Za-z0-9._-]\+\)\+\.ini' | grep -v xdebug | xargs awk 'FNR==1{print ""}1' > "${temporaryPath}"
     php -n -c "${temporaryPath}" "$@"
@@ -20,20 +110,32 @@ php_no_xdebug () {
     exit $RETURN
 }
 
-DRYRUN=""
-
-if [ "$1" = "dryrun" ]
-then
-    DRYRUN="--dry-run --diff --diff-format udiff"
+# ------------------------------------
+# --- get a list of files to check ---
+# ------------------------------------
+if [[ $filestype == commit ]];then
+    echo "$progname: Searching for php files in latest git commit ..."
+    DETECTED_FILES=`git diff-tree --no-commit-id --name-only -r HEAD | grep '.php$' 2>/dev/null`
+elif [[ $filestype == cache ]];then
+    echo "$progname: Searching for php files in git cache ..."
+    DETECTED_FILES=`git diff --cached --name-only | grep '.php$' 2>/dev/null`
+elif [[ $filestype == stdin ]];then
+    echo "$progname: reading list of php files to check from stdin"
+    DETECTED_FILES=$(cat)
+else
+    echo "$progname: ERROR: unknown filetype, possibly used -f with wrong argument"
+    usage
 fi
-
-DETECTED_FILES=`git diff-tree --no-commit-id --name-only -r HEAD | grep '.php$' 2>/dev/null`
 if [ -z "${DETECTED_FILES}" ]
 then
-    echo "No PHP files to check in current commit, all is well."
+    echo "$progname: No PHP files to check, all is well."
     exit 0
 fi
 
+# ---------------------------------
+# --- run php-cs-fixer on files ---
+# ---------------------------------
+exist_php_executable
 php_no_xdebug ./bin/php-cs-fixer fix \
     -v ${DRYRUN} \
     --config=Build/.php_cs \
diff --git a/Build/git-hooks/commit-msg b/Build/git-hooks/commit-msg
new file mode 100755 (executable)
index 0000000..4e4fb19
--- /dev/null
@@ -0,0 +1,249 @@
+#!/usr/bin/env bash
+# From TYPO3 CI Review 1.1
+# original version Gerrit Code Review 2.14.6
+#
+# Part of Gerrit Code Review (http://code.google.com/p/gerrit/)
+#
+# Copyright (c) 2012-2015 TYPO3 CMS (Markus Klein)
+# Copyright (c) 2009 The Android Open Source Project
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+#
+# Changes for TYPO3:
+# - check for line length
+# - check for commit type (e.g. BUG)
+# - check for Resolves
+# - check for Releases
+# - put Change-Id after Resolves / Releases footer
+
+
+unset GREP_OPTIONS
+
+MSG="$1"
+
+# Check for, and add if missing, a unique Change-Id
+#
+add_ChangeId() {
+       clean_message=`sed -e '
+               /^diff --git .*/{
+                       s///
+                       q
+               }
+               /^Signed-off-by:/d
+               /^#/d
+       ' "$MSG" | git stripspace`
+       if test -z "$clean_message"
+       then
+               return
+       fi
+
+       # Do not add Change-Id to temp commits
+       if echo "$clean_message" | head -1 | grep -q '^\(fixup\|squash\)!'
+       then
+               return
+       fi
+
+       if test "false" = "`git config --bool --get gerrit.createChangeId`"
+       then
+               return
+       fi
+
+       # Does Change-Id: already exist? if so, exit (no change).
+       if grep -i '^Change-Id:' "$MSG" >/dev/null
+       then
+               return
+       fi
+
+       id=`_gen_ChangeId`
+       T="$MSG.tmp.$$"
+       AWK=awk
+       if [ -x /usr/xpg4/bin/awk ]; then
+               # Solaris AWK is just too broken
+               AWK=/usr/xpg4/bin/awk
+       fi
+
+       # Get core.commentChar from git config or use default symbol
+       commentChar=`git config --get core.commentChar`
+       commentChar=${commentChar:-#}
+
+       # How this works:
+       # - parse the commit message as (textLine+ blankLine*)*
+       # - assume textLine+ to be a footer until proven otherwise
+       # - exception: the first block is not footer (as it is the title)
+       # - read textLine+ into a variable
+       # - then count blankLines
+       # - once the next textLine appears, print textLine+ blankLine* as these
+       #   aren't footer
+       # - in END, the last textLine+ block is available for footer parsing
+       $AWK '
+       BEGIN {
+               # while we start with the assumption that textLine+
+               # is a footer, the first block is not.
+               isFooter = 0
+               footerComment = 0
+               blankLines = 0
+       }
+
+       # Skip lines starting with commentChar without any spaces before it.
+       /^'"$commentChar"'/ { next }
+
+       # Skip the line starting with the diff command and everything after it,
+       # up to the end of the file, assuming it is only patch data.
+       # If more than one line before the diff was empty, strip all but one.
+       /^diff --git / {
+               blankLines = 0
+               while (getline) { }
+               next
+       }
+
+       # Count blank lines outside footer comments
+       /^$/ && (footerComment == 0) {
+               blankLines++
+               next
+       }
+
+       # Catch footer comment
+       /^\[[a-zA-Z0-9-]+:/ && (isFooter == 1) {
+               footerComment = 1
+       }
+
+       /]$/ && (footerComment == 1) {
+               footerComment = 2
+       }
+
+       # We have a non-blank line after blank lines. Handle this.
+       (blankLines > 0) {
+               print lines
+               for (i = 0; i < blankLines; i++) {
+                       print ""
+               }
+
+               lines = ""
+               blankLines = 0
+               isFooter = 1
+               footerComment = 0
+       }
+
+       # Detect that the current block is not the footer
+       (footerComment == 0) && (!/^\[?[a-zA-Z0-9-]+:/ || /^[a-zA-Z0-9-]+:\/\//) {
+               isFooter = 0
+       }
+
+       {
+               # We need this information about the current last comment line
+               if (footerComment == 2) {
+                       footerComment = 0
+               }
+               if (lines != "") {
+                       lines = lines "\n";
+               }
+               lines = lines $0
+       }
+
+       # Footer handling:
+       # Our footer handling is different from original footer handling in Gerrit.
+       # We dont consider CHANGE_ID_AFTER.
+       #
+       # Just print the footer block, a new line and the Change-Id
+       END {
+               unprinted = 1
+               if (isFooter == 0) {
+                       print lines "\n"
+                       lines = ""
+               }
+               numlines = split(lines, footer, "\n")
+               for (line = 1; line <= numlines; line++) {
+                       print footer[line]
+               }
+               if (unprinted) {
+                       print "Change-Id: I'"$id"'"
+               }
+       }' "$MSG" > "$T" && mv "$T" "$MSG" || rm -f "$T"
+}
+_gen_ChangeIdInput() {
+       echo "tree `git write-tree`"
+       if parent=`git rev-parse "HEAD^0" 2>/dev/null`
+       then
+               echo "parent $parent"
+       fi
+       echo "author `git var GIT_AUTHOR_IDENT`"
+       echo "committer `git var GIT_COMMITTER_IDENT`"
+       echo
+       printf '%s' "$clean_message"
+}
+_gen_ChangeId() {
+       _gen_ChangeIdInput |
+       git hash-object -t commit --stdin
+}
+
+COMMIT_MSG_ERROR_FOUND=0
+MSG="$1"
+ERROR_TEXT="\n"
+
+# Check for maximum line length
+#
+checkForLineLength() {
+       if egrep -q '^[^#].{74}' "$MSG"; then
+               COMMIT_MSG_ERROR_FOUND=1
+               ERROR_TEXT="${ERROR_TEXT} - The maximum line length of 74 characters is exceeded.\n"
+       fi
+}
+
+# Check for existence of the commit type text
+#
+checkForCommitType() {
+       if ! egrep -q '\[[^]]+\] .+$' "$MSG"; then
+               COMMIT_MSG_ERROR_FOUND=1
+               ERROR_TEXT="${ERROR_TEXT} - Your first line has to contain a commit type like '[BUGFIX]'.\n"
+       fi
+}
+
+# Check for existence of a "Resolves: " line.
+#
+checkForResolves() {
+       if ! egrep -q '^(Resolves|Fixes): \#[0-9]+$' "$MSG"; then
+               COMMIT_MSG_ERROR_FOUND=1
+               ERROR_TEXT="${ERROR_TEXT} - You need at least one 'Resolves|Fixes: #<issue number>' line.\n"
+       fi
+}
+
+# Check for existence of a "Releases: " line.
+#
+checkForReleases() {
+       if ! egrep -q '^Releases: (master|[0-9]\.[0-9])(, *(master|[0-9]\.[0-9]))*$' "$MSG"; then
+               COMMIT_MSG_ERROR_FOUND=1
+               ERROR_TEXT="${ERROR_TEXT} - You need a 'Releases:' line. For instance: Releases: master, 8.7\n"
+       fi
+}
+
+checkForLineLength
+checkForCommitType
+checkForResolves
+checkForReleases
+
+# Abort commit on message format errors
+if [ $COMMIT_MSG_ERROR_FOUND -eq 1 ]; then
+       echo -e " "
+       echo -e "------------------------------------------------------------------"
+       echo -e " >> ERROR in your commit message:                                 "
+       echo -e "  $ERROR_TEXT"
+       echo -e " "
+       echo -e "  Please refer to [1] for details on the commit requirements.     "
+       echo -e "  You should fix this and then do commit --amend etc.             "
+       echo -e "  [1] https://docs.typo3.org/typo3cms/ContributionWorkflowGuide/latest/singlehtml/Index.html#commit-message-rules-for-typo3-cms"
+       echo -e "------------------------------------------------------------------\n"
+fi
+
+add_ChangeId
diff --git a/Build/git-hooks/unix+mac/pre-commit b/Build/git-hooks/unix+mac/pre-commit
new file mode 100755 (executable)
index 0000000..eb96422
--- /dev/null
@@ -0,0 +1,48 @@
+#!/usr/bin/env bash
+
+# pre-commit hook
+# - check if staged files adhere to Coding Guidelines
+# - abort on error:no for now, override with environment variable TYPO3_GIT_HOOK_ABORT_ON_ERROR
+#
+# Dependencies:
+#   uses: Build/Scripts/cglFixMyCommit.sh
+#
+
+script=Build/Scripts/cglFixMyCommit.sh
+
+ABORT_ON_ERROR="no"
+ERROR_TEXT="\n"
+ERROR_CODE=0
+
+if [ -z "${TYPO3_GIT_HOOK_ABORT_ON_ERROR+x}" ]; then
+    ABORT_ON_ERROR=${TYPO3_GIT_HOOK_ABORT_ON_ERROR}
+fi
+
+if [ ! -x $script ];then
+    "echo "$script does not exist or is not executable"
+    "exit 0
+fi
+
+# call script with -f <cache> parameter: check files in git cache (staging area)
+# call script dryrun parameter: only check, do not fix
+$script -f cache -n
+ERROR_CODE=$?
+
+
+if [ ${ERROR_CODE} -ne 0 ];then
+     echo -e "\n-----------------------------------------------------------------\n"
+     echo -e "  >> ERROR: There was a coding guideline problem in one or more of  "
+     echo -e "              your php files.                                       "
+     echo -e "   Please refer to [1] for details on the coding guidelines         "
+     echo -e "   Please refer to [2] for details on contribution                  "
+     echo -e "   [1] https://docs.typo3.org/typo3cms/CoreApiReference/CodingGuidelines/Index.html"
+     echo -e "   [2] https://docs.typo3.org/typo3cms/ContributionWorkflowGuide/   "
+     echo -e "------------------------------------------------------------------\n"
+     if [[ ${ABORT_ON_ERROR} == "yes" ]];then
+         echo -e "   Your commit is being aborted ... Fix and try again!          "
+         exit 1
+     else
+         echo -e "   You must fix this and then commit again (git commit --amend) "
+     fi
+fi
+exit 0